#ifndef ARCH_DISKDUMPELF_H
#define ARCH_DISKDUMPELF_H

/* $Id: diskdumpelf.h,v 1.1 2004/06/06 22:50:01 tachino Exp $ */

/*
 * elf_gregset_t contains the application-level state in the following order:
 *      r0-r31
 *      NaT bits (for r0-r31; bit N == 1 iff rN is a NaT)
 *      predicate registers (p0-p63)
 *      b0-b7
 *      ip cfm psr
 *      ar.rsc ar.bsp ar.bspstore ar.rnat
 *      ar.ccv ar.unat ar.fpsr ar.pfs ar.lc ar.ec
 */
#define ELF_NGREG	128	/* we really need just 72 but let's leave some headroom... */
typedef unsigned long elf_greg_t;
typedef elf_greg_t elf_gregset_t[ELF_NGREG];

#define MACHINE_TYPE	EM_IA_64
#define ELF_CLASS	ELFCLASS64
#define PAGE_OFFSET	0xe000000000000000

#endif /* ARCH_DISKDUMPELF_H */
