#ifndef DUMPFILTER_H
#define DUMPFILTER_H

/* $Id: dumpfilter.h,v 1.5 2007/04/27 22:01:13 tachino Exp $ */

#define PG_locked	 	 0	/* Page is locked. Don't touch. */
#define PG_error		 1
#define PG_referenced		 2
#define PG_uptodate		 3

#define PG_dirty	 	 4
#define PG_lru			 5
#define PG_active		 6
#define PG_slab			 7	/* slab debug (Suparna wants this) */

#define PG_highmem		 8
#define PG_checked		 9	/* kill me in 2.5.<early>. */
#define PG_arch_1		10
#define PG_reserved		11

#define PG_private		12	/* Has something at ->private */
#define PG_writeback		13	/* Page is under writeback */
#define PG_nosave		14	/* Used for system suspend/resume */
#define PG_compound		15	/* Part of a compound page */

#define PG_swapcache		16	/* Swap page: swp_entry_t in private */
#define PG_mappedtodisk		17	/* Has blocks allocated on-disk */
#define PG_reclaim		18	/* To be reclaimed asap */

extern inline int test_bit(int nr, const void *_addr)
{
	int	mask;
	const unsigned long *addr = _addr;

	addr += nr >> 5;
	mask = 1 << (nr & 0x1f);
	return ((mask & *addr) != 0);
}

#define PagePrivate(pd)		test_bit(PG_private, &(pd)->page_flags)
#define PageLRU(pd)		test_bit(PG_lru, &(pd)->page_flags)
#define PageSwapCache(pd)	test_bit(PG_swapcache, &(pd)->page_flags)

/* Dump Level */
#define DUMP_EXCLUDE_CACHE 0x00000001	/* Exclude LRU & SwapCache pages*/
#define DUMP_EXCLUDE_CLEAN 0x00000002	/* Exclude all-zero pages */
#define DUMP_EXCLUDE_FREE  0x00000004	/* Exclude free pages */
#define DUMP_EXCLUDE_ANON  0x00000008	/* Exclude Anon pages */
#define DUMP_SAVE_PRIVATE  0x00000010	/* Save private pages */

#define DEFAULT_DUMP_LEVEL 19		/* recommended */

#endif
