/*
 *  Copyright (C) 2007  FUJITSU LIMITED
 */
/* $Id: syslog.c,v 1.3 2007/05/04 14:50:35 akira Exp $ */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <fcntl.h>
#include <stdarg.h>
#include "syslog.h"

static char *kernel_message(const char *line)
{
	darray_string *da;
	char *msg = NULL;

	/* Feb 27 13:00:25 host kernel: msg... */
	da = split(line, NULL, 5);

	if (da->length != 6)
		goto err;

	if (strcmp(da->ary[4], "kernel:") != 0)
		goto err;

	msg = darray_string_pop(da);

err:
	darray_string_free(da);
	return msg;
}

darray_string *last_kernel_messages(const char *filename)
{
	FILE *fp;
	char line[BUFSIZ], *kmsg;
	darray_string *msgs = darray_string_alloc();

	if ((fp = fopen(filename, "r")) == NULL) {
		darray_free(msgs);
		return NULL;
	}

	while (fgets(line, sizeof(line), fp) != NULL) {
		if ((kmsg = kernel_message(line)) == NULL)
			continue;

		if (start_with(kmsg, "Linux version"))
			darray_string_clear(msgs);

		darray_string_push(msgs, chop(kmsg, NULL));
	}

	fclose(fp);

	return msgs;
}
